commit 8b522708e002efe90c835c5928ef47d94aeb78eb
Author: Štěpán Červenka <stepan.cervenka1@gmail.com>
Date:   Sun May 2 20:15:00 2021 +0200

    Re #8774 - Implementovat pracovní verzi grafů pro jednotku
    
    * decomposition on vega source files
    * different loading on sensor
    + add unit graphs

diff --git a/src/app/sensor/components/sensor.component.ts b/src/app/sensor/components/sensor.component.ts
index ca0cf2c..76f88db 100644
--- a/src/app/sensor/components/sensor.component.ts
+++ b/src/app/sensor/components/sensor.component.ts
@@ -46,6 +46,7 @@ export class SensorComponent implements OnInit {
     let spec = this.getGraphType(sensorId);
     const vega = require('vega');
     const vegaTooltip = require('vega-tooltip');
+    const config = require('/src/vega/config.json');
 
     spec.data[0].values = data;
     spec.signals[0].value = interval;
@@ -74,7 +75,7 @@ export class SensorComponent implements OnInit {
       "shortMonths": ["led", "úno", "břez", "dub", "kvě", "čer", "červ", "srp", "zář", "říj", "list", "pros"]
     });
 
-    let view = new vega.View(vega.parse(spec))
+    let view = new vega.View(vega.parse(spec, config))
       .tooltip(handler.call)
       .initialize('#view')
       .hover()
@@ -86,18 +87,32 @@ export class SensorComponent implements OnInit {
   }
 
   getGraphType(sensorId) {
-    let spec;
+    const lodash = require('lodash/object');
 
     if(sensorId >= 480000000 && sensorId < 490000000) {
-      spec = require('/src/vega/aggregate-barchart.json');
+
+      let base = require('/src/vega/base/default.json');
+      let chart = require('/src/vega/body/barchart.json');
+      let tooltip = require('/src/vega/tooltip/samm-tooltip.json')
+      return lodash.merge(base, chart, tooltip);
+
     } else if((sensorId >= 470020000 && sensorId <  470030000) || (sensorId >=470060000 && sensorId < 470090000) ||
       (sensorId >= 470130000 && sensorId < 470140000) || (sensorId >=470180000 && sensorId < 470190000)) {
-      spec = require('/src/vega/aggregate-windchart.json');
+
+      let base = require('/src/vega/base/default.json');
+      let chart = require('/src/vega/body/windchart.json');
+      let tooltip = require('/src/vega/tooltip/samm-tooltip.json')
+      return lodash.merge(base, chart, tooltip);
+
     } else {
-      spec = require('/src/vega/aggregate-linechart.json');
+
+      let base = require('/src/vega/base/default.json');
+      let chart = require('/src/vega/body/linechart.json');
+      let tooltip = require('/src/vega/tooltip/samm-tooltip.json')
+      return lodash.merge(base, chart, tooltip);
+
     }
 
-    return spec;
 
   }
 
diff --git a/src/app/unit/components/unit.component.ts b/src/app/unit/components/unit.component.ts
index 6802323..f88d65c 100644
--- a/src/app/unit/components/unit.component.ts
+++ b/src/app/unit/components/unit.component.ts
@@ -6,6 +6,8 @@ import {Sensors} from '../../shared/api/endpoints/models/sensors';
 import {AggreationModel} from '../../shared/models/aggreation.model';
 import * as moment from 'moment-timezone';
 
+declare var require: any
+
 @Component({
   selector: 'app-unit',
   templateUrl: './unit.component.html',
@@ -15,6 +17,7 @@ export class UnitComponent implements OnInit {
 
   preselectedSensors: string;
   unitId: number;
+  viewCount = 0;
   data;
   rangeDates: Date[];
   aggregationFunction: AggreationModel[];
@@ -46,7 +49,7 @@ export class UnitComponent implements OnInit {
 
   showGraph() {
     let agg = 'HOUR';
-    let range: Date[] = [moment().subtract(12, 'months').toDate(), moment().toDate()];
+    let range: Date[] = [moment().subtract(6, 'months').toDate(), moment().toDate()];
     if (this.selectedAggregationFunction) {
       agg = this.selectedAggregationFunction;
     }
@@ -59,9 +62,103 @@ export class UnitComponent implements OnInit {
       from: moment(range[0]).format('yyyy-MM-DD HH:mm:ssZ').slice(0, -3),
       to: moment(range[1]).format('yyyy-MM-DD HH:mm:ssZ').slice(0, -3), interval: agg}).pipe(
       tap(data => {
-        this.data = Object.entries(data);
-        console.log(this.data);
+        //this.data = Object.entries(data);
+        //console.log(this.data);
+        var objectKeys = Object.keys(data);
+        for(const key of objectKeys ) {
+          this.getGraph(key, data[key]["data"], data[key]["interval"]);
+        }
       })
     ).subscribe();
   }
+
+  getGraph(sensorId, data, interval) {
+    let spec = this.getGraphType(sensorId);
+    let elementName = this.createView();
+    const vega = require('vega');
+    const config = require('/src/vega/config.json');
+    const vegaTooltip = require('vega-tooltip');
+
+    spec.data[0].values = data;
+    spec.signals[0].value = interval;
+
+
+    let handler = new vegaTooltip.Handler();
+
+
+    const loc = vega.locale({
+      "decimal": ",",
+      "thousands": "\u00a0",
+      "grouping": [3],
+      "currency": ["", "\u00a0Kč"]
+    },{
+      "dateTime": "%A,%e.%B %Y, %X",
+      "date": "%-d.%-m.%Y",
+      "time": "%H:%M:%S",
+      "periods": ["AM", "PM"],
+      "days": ["neděle", "pondělí", "úterý", "středa", "čvrtek", "pátek", "sobota"],
+      "shortDays": ["ne.", "po.", "út.", "st.", "čt.", "pá.", "so."],
+      "months": ["leden", "únor", "březen", "duben", "květen", "červen", "červenec", "srpen", "září", "říjen", "listopad", "prosinec"],
+      "shortMonths": ["led", "úno", "břez", "dub", "kvě", "čer", "červ", "srp", "zář", "říj", "list", "pros"]
+    });
+
+    let view = new vega.View(vega.parse(spec, config))
+      .tooltip(handler.call)
+      .initialize(elementName)
+      .hover()
+      .locale(loc)
+      .runAsync();
+
+
+
+  }
+
+  getGraphType(sensorId) {
+    const lodash = require('lodash/object');
+
+    if(sensorId >= 480000000 && sensorId < 490000000) {
+
+      let rvalue: any = {};
+      let base = require('/src/vega/base/default.json');
+      let chart = require('/src/vega/body/barchart.json');
+      let tooltip = require('/src/vega/tooltip/samm-tooltip.json')
+      lodash.merge(rvalue, base, chart, tooltip);
+      return rvalue;
+
+    } else if((sensorId >= 470020000 && sensorId <  470030000) || (sensorId >=470060000 && sensorId < 470090000) ||
+      (sensorId >= 470130000 && sensorId < 470140000) || (sensorId >=470180000 && sensorId < 470190000)) {
+
+      let rvalue: any = {};
+      let base = require('/src/vega/base/default.json');
+      let chart = require('/src/vega/body/windchart.json');
+      let tooltip = require('/src/vega/tooltip/samm-tooltip.json')
+      lodash.merge(rvalue, base, chart, tooltip);
+      return rvalue;
+
+    } else {
+
+      let rvalue: any = {};
+      let base = require('/src/vega/base/default.json');
+      let chart = require('/src/vega/body/linechart.json');
+      let tooltip = require('/src/vega/tooltip/samm-tooltip.json')
+      lodash.merge(rvalue, base, chart, tooltip);
+      return rvalue;
+
+    }
+
+
+  }
+
+  createView() {
+    let div = document.createElement("div");
+    let name = "view" + this.viewCount;
+    div.id = name;
+    this.viewCount++;
+
+    let container = document.getElementById("vega_container");
+    container.appendChild(div);
+
+    return '#' + name;
+
+  }
 }
